﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Windows.Data;
using System.Globalization;

namespace _2010_12_02_XamGridComboEditor
{


    public class CategoryList : List<Category>
    {
        public CategoryList()
        {
            this.AddRange(CategoryProviderX.GetList());
        }
    }

    public class CategoryProviderX
    {
        static List<Category> _list;

        public static List<Category>  GetList()
        {
            if (_list == null)
            {
                _list = new List<Category>();
                _list.Add(new Category("Red"));
                _list.Add(new Category("Blue"));
                _list.Add(new Category("Green"));
                _list.Add(new Category("Orange"));
            }

            return _list;
        }

    }
    
    public class Category
    {
        string _categoryName;

        public Category(string catName)
        {
            _categoryName = catName;
        }

        public string CategoryName
        {
            get { return _categoryName; }
            set { _categoryName = value; }
        }

    }



    public class CategoryConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Category selectedItem = null;
            CategoryList values = parameter as CategoryList;
            if (values != null)
            {
                string selectedValue = (string)value;
                foreach (Category item in values)
                {
                    if (item.CategoryName == selectedValue)
                    {
                        selectedItem = item;
                        break;
                    }
                }
            }
            return selectedItem;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string result = string.Empty;

            Category selectedType = value as Category;
            if (selectedType != null)
            {
                result = selectedType.CategoryName;
            }

            return result;
        }

    }
}